diff --git a/.mailmap b/.mailmap
index dc30369117..9d66fa727c 100644
--- a/.mailmap
+++ b/.mailmap
@@ -588,6 +588,7 @@ Jens Freimann <jfreimann@redhat.com> <jfreiman@redhat.com>
 Jeremy Plsek <jplsek@iol.unh.edu>
 Jeremy Spewock <jspewock@iol.unh.edu>
 Jerin Jacob <jerinj@marvell.com> <jerin.jacob@caviumnetworks.com> <jerinjacobk@gmail.com>
+Jeroen de Borst <jeroendb@google.com>
 Jerome Jutteau <jerome.jutteau@outscale.com>
 Jerry Hao OS <jerryhao@os.amperecomputing.com>
 Jerry Lilijun <jerry.lilijun@huawei.com>
diff --git a/drivers/net/gve/base/gve.h b/drivers/net/gve/base/gve.h
index 2dc4507acb..55b7c2688e 100644
--- a/drivers/net/gve/base/gve.h
+++ b/drivers/net/gve/base/gve.h
@@ -1,6 +1,5 @@
-/* SPDX-License-Identifier: MIT
- * Google Virtual Ethernet (gve) driver
- * Copyright (C) 2015-2022 Google, Inc.
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2022-2023 Google LLC
  */
 
 #ifndef _GVE_H_
diff --git a/drivers/net/gve/base/gve_adminq.c b/drivers/net/gve/base/gve_adminq.c
index e745b709b2..3519a2217f 100644
--- a/drivers/net/gve/base/gve_adminq.c
+++ b/drivers/net/gve/base/gve_adminq.c
@@ -1,6 +1,5 @@
-/* SPDX-License-Identifier: MIT
- * Google Virtual Ethernet (gve) driver
- * Copyright (C) 2015-2022 Google, Inc.
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2022-2023 Google LLC
  */
 
 #include "../gve_ethdev.h"
diff --git a/drivers/net/gve/base/gve_adminq.h b/drivers/net/gve/base/gve_adminq.h
index 05550119de..76862a148e 100644
--- a/drivers/net/gve/base/gve_adminq.h
+++ b/drivers/net/gve/base/gve_adminq.h
@@ -1,6 +1,6 @@
-/* SPDX-License-Identifier: MIT
- * Google Virtual Ethernet (gve) driver
- * Copyright (C) 2015-2022 Google, Inc.
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2022-2023 Google LLC
+
  */
 
 #ifndef _GVE_ADMINQ_H
diff --git a/drivers/net/gve/base/gve_desc.h b/drivers/net/gve/base/gve_desc.h
index 006b36442f..0df97eacaf 100644
--- a/drivers/net/gve/base/gve_desc.h
+++ b/drivers/net/gve/base/gve_desc.h
@@ -1,6 +1,6 @@
-/* SPDX-License-Identifier: MIT
- * Google Virtual Ethernet (gve) driver
- * Copyright (C) 2015-2022 Google, Inc.
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2022-2023 Google LLC
+
  */
 
 /* GVE Transmit Descriptor formats */
diff --git a/drivers/net/gve/base/gve_desc_dqo.h b/drivers/net/gve/base/gve_desc_dqo.h
index ee1afdecb8..fef9c21da9 100644
--- a/drivers/net/gve/base/gve_desc_dqo.h
+++ b/drivers/net/gve/base/gve_desc_dqo.h
@@ -1,6 +1,6 @@
-/* SPDX-License-Identifier: MIT
- * Google Virtual Ethernet (gve) driver
- * Copyright (C) 2015-2022 Google, Inc.
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2022-2023 Google LLC
+
  */
 
 /* GVE DQO Descriptor formats */
diff --git a/drivers/net/gve/base/gve_osdep.h b/drivers/net/gve/base/gve_osdep.h
index 7cb73002f4..92efe3c594 100644
--- a/drivers/net/gve/base/gve_osdep.h
+++ b/drivers/net/gve/base/gve_osdep.h
@@ -1,5 +1,6 @@
 /* SPDX-License-Identifier: BSD-3-Clause
- * Copyright(C) 2022 Intel Corporation
+ * Copyright (c) 2022-2023 Google LLC
+
  */
 
 #ifndef _GVE_OSDEP_H_
diff --git a/drivers/net/gve/base/gve_register.h b/drivers/net/gve/base/gve_register.h
index c674167f31..3ee4e65815 100644
--- a/drivers/net/gve/base/gve_register.h
+++ b/drivers/net/gve/base/gve_register.h
@@ -1,6 +1,6 @@
-/* SPDX-License-Identifier: MIT
- * Google Virtual Ethernet (gve) driver
- * Copyright (C) 2015-2022 Google, Inc.
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2022-2023 Google LLC
+
  */
 
 #ifndef _GVE_REGISTER_H_
diff --git a/license/exceptions.txt b/license/exceptions.txt
index 1ded290eee..1bd4dbf8f7 100644
--- a/license/exceptions.txt
+++ b/license/exceptions.txt
@@ -16,5 +16,4 @@ SPDX Identifier     TB Approval Date  GB Approval Date  File name
 2.BSD-2-Clause      10/23/2019        12/18/2019        lib/eal/windows/include/getopt.h
 3.ISC AND
   BSD-2-Clause      10/23/2019        12/18/2019        lib/eal/windows/getopt.c
-4. MIT              10/19/2022        10/18/2022        drivers/net/gve/base/*
 ---------------------------------------------------------------------------------------------------